Package org.h2.samples

# Class UpdatableView

java.lang.Object
org.h2.tools.TriggerAdapter
org.h2.samples.UpdatableView

All Implemented Interfaces:
  `Trigger`

public class UpdatableView extends TriggerAdapter
This sample application shows how to use triggers to create updatable views.

## Field Summary

### Fields inherited from class org.h2.tools.TriggerAdapter

`before, schemaName, tableName, triggerName, type`

### Fields inherited from interface org.h2.api.Trigger

`DELETE, INSERT, SELECT, UPDATE`

## Constructor Summary

Constructors
Constructor
Description
`UpdatableView()`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
This method is called when the database is closed.
`void`
`fire(Connection conn, ResultSet oldRow, ResultSet newRow)`
This method is called for each triggered action by the default fire(Connection conn, Object[] oldRow, Object[] newRow) method.
`void`
`init(Connection conn, String schemaName, String triggerName, String tableName, boolean before, int type)`
This method is called by the database engine once when initializing the trigger.
`static void`
`main(String... args)`
This method is called when executing this sample application from the command line.

### Methods inherited from class org.h2.tools.TriggerAdapter

`fire`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.h2.api.Trigger

`remove`

## Constructor Details

### UpdatableView

public UpdatableView()

## Method Details

### main

public static void main(String... args) throws Exception
This method is called when executing this sample application from the command line.

Parameters:
  `args` - ignored
Throws:
  `Exception` - on failure

### init

public void init(Connection conn, String schemaName, String triggerName, String tableName, boolean before, int type) throws SQLException
Description copied from class: `TriggerAdapter`
This method is called by the database engine once when initializing the trigger. It is called when the trigger is created, as well as when the database is opened. The default implementation initialized the result sets.

Specified by:
  `init` in interface `Trigger`
Overrides:
  `init` in class `TriggerAdapter`
Parameters:
  `conn` - a connection to the database
  `schemaName` - the name of the schema
  `triggerName` - the name of the trigger used in the CREATE TRIGGER statement
  `tableName` - the name of the table
  `before` - whether the fire method is called before or after the operation is performed
  `type` - the operation type: INSERT, UPDATE, DELETE, SELECT, or a combination (this parameter is a bit field)
Throws:
  `SQLException` - on SQL exception

### fire

public void fire(Connection conn, ResultSet oldRow, ResultSet newRow) throws SQLException
Description copied from class: `TriggerAdapter`
This method is called for each triggered action by the default fire(Connection conn, Object[] oldRow, Object[] newRow) method.

For "before" triggers, the new values of the new row may be changed using the ResultSet.updateX methods.

Specified by:
  `fire` in class `TriggerAdapter`
Parameters:
  `conn` - a connection to the database
  `oldRow` - the old row, or null if no old row is available (for INSERT)
  `newRow` - the new row, or null if no new row is available (for DELETE)
Throws:
  `SQLException` - if the operation must be undone

### close

public void close() throws SQLException
Description copied from interface: `Trigger`
This method is called when the database is closed. If the method throws an exception, it will be logged, but closing the database will continue.

Throws:
  `SQLException` - on SQL exception